#include "stm32f4xx.h"
#include "i2c.h"
#include "stdio.h"
#include "LiquidCrystal_PCF8574.h"

uint16_t var;
char str[40];

volatile uint8_t parallelData;


int main()
	{
		/*LCD Stuff*/
		i2c_init();
		lcd_init();
		lcd_clear();

		/*Enable clock access to GPIOC*/
		RCC->AHB1ENR|=RCC_AHB1ENR_GPIOCEN;
		/*Set PC0 to PC7 as input*/
		GPIOC->MODER&=~(GPIO_MODER_MODE0|GPIO_MODER_MODE1|GPIO_MODER_MODE2
				|GPIO_MODER_MODE3|GPIO_MODER_MODE4|GPIO_MODER_MODE5|GPIO_MODER_MODE6
				|GPIO_MODER_MODE7);

		/*Enable Clock access to GPIOA*/

		RCC->AHB1ENR|=RCC_AHB1ENR_GPIOAEN;
		/*Set PA0 as input*/
		GPIOA->MODER&=~GPIO_MODER_MODE0;

		/*Enable clock access to syscfg*/

		RCC->APB2ENR|=RCC_APB2ENR_SYSCFGEN;

		/*Set EXTI0 to be portA*/

		SYSCFG->EXTICR[0]|=SYSCFG_EXTICR1_EXTI0_PA;

		/*Unmask line0*/
		EXTI->IMR|=EXTI_IMR_IM0;

		/*Set detection to falling edge*/
		EXTI->FTSR|=EXTI_FTSR_TR0;

		/*Enable the EXTI0 in NVIC*/

		NVIC_EnableIRQ(EXTI0_IRQn);

		while(1)
		{
			setCursor(0, 0);
			sprintf(str,"Received data=%d   ",parallelData);
			lcd_send_string(str);
		}
	}

void EXTI0_IRQHandler (void)
{
	if ((EXTI->PR & EXTI_PR_PR0) == EXTI_PR_PR0)
	{
		/*Get the new data*/
		parallelData=(uint8_t)GPIOC->IDR;

		/*Clear the pending flag*/
		EXTI->PR |= EXTI_PR_PR0;

	}
}
